<?php
// -----------------------------------------------------------
// GChat Video Chat - http://www.gchat.com/video-chat.html
// Copyright (C) 2013 GChat Limited. All rights reserved.
// GChat Video Chat is not a free software, see LICENSE file
// -----------------------------------------------------------
 
defined('VISICHAT_START') or die("Access Denied");

/**
 * GChat Video Chat IntegrationModule integration class
 *
 */
 abstract class IntegrationModule
 {
	protected $membersTable 		= "";
    protected $idField 				= "";
    protected $usernameField 		= "";
    protected $passwordField 		= "";
    protected $emailField 			= "";
	protected $pictureField			= "";
	protected $userAccessField		= "";
    protected $integrationPrefix 	= "";
	 
	 
	/** 
	* IntegrationModule object constructor
	*
	* @access	public
	*/	
	function __construct()
	{
		$setting 				= Factory::getClass("Setting");
		$this->membersTable 	= $setting->get("members_table");
		$this->idField 			= $setting->get("id_field");
		$this->usernameField 	= $setting->get("username_field");
		$this->passwordField 	= $setting->get("password_field");
		$this->emailField 		= $setting->get("email_field");
		$this->pictureField		= $setting->get("picture_field");
		$this->userAccessField	= $setting->get("user_access_field");
		$this->integrationPrefix= $setting->get("integrate_prefix");
	 }
	 
	 abstract function allowRegistration();
	 abstract function getName();
	 abstract function getLabel();
	 abstract function getCurrentUserId();
	 abstract function getPicture( $userId );
	 abstract function getBirthday( $userId );
	 abstract function getGender( $userId );
	 abstract function encryptPassword( $password , $userId = "" );

 }
 ?>