<?php
// -----------------------------------------------------------
// GChat Video Chat - http://www.gchat.com/video-chat.html
// Copyright (C) 2013 GChat Limited. All rights reserved.
// GChat Video Chat is not a free software, see LICENSE file
// -----------------------------------------------------------
 
defined('VISICHAT_START') or die("Access Denied");

require_once "IntegrationModule.class.php";

/*
 * Video Chat PHPBB integration class
 *
 */
 class PHPBB extends IntegrationModule
 {
	 
	 private $allowRegistration = false;	 

	 /**
	* PHPBB object constructor
	*
	* @access	public
	*/	
	function __construct()
	{
		parent::__construct(); 
	}
	
	/**
	* Indicates whether when this integration is used, can use register or not.
	*
	* @return boolean
	*/
	public function allowRegistration()
	{
		return $this->allowRegistration;
	}
	
	/**
	* Get the module name
	*
	* @return string
	*/
	public function getName()
	{
		return "PHPBB";
	}
	
	/**
	* Get the module label
	*
	* @return string
	*/
	public function getLabel()
	{
		return "PHPBB";
	}
	
	/**
	* Get user id of the user from session data
	*
	* @return integer
	*/
	public function getCurrentUserId()
	{	
	
		$sessionId = $_COOKIE["phpbb3_ip7hu_sid"];   // Edit this
		
		// Database instance
		$db = Factory::getDatabase();
		
		$result = $db->query("select * from " . $db->escape ( $this->integrationPrefix ) . "sessions where session_id = '" . $db->escape ( $sessionId ) . "'");
		
		if ( count ( $result ) > 0 )
		{
			return ( $result [0]["session_user_id"] );
		}
		
		return "";
	}
	
	/**
	* Get picture of the user
	*
	* @return string
	*/
	public function getPicture( $userId )
	{
		return "";
	}
	
	/**
	* Get the user birthday
	*
	* @return timestamp
	*/
	public function getBirthday ( $userId )
	{
		return "";
	}
	
	/**
	* Get the user gender
	*
	* @return string m (male), f (female), n (not specified), c (couple)
	*/
	public function getGender ( $userId )
	{
		return "";
	}
	
	/**
	* Encrypt the user password
	*
	* @return string	encrypted password
	*/
	public function encryptPassword ( $password, $userId = "" )
	{
		
		if ( $userId == "" )
		{
			throw new Exception ("User ID is required");
		}
		
		// Database instance
		$db = Factory::getDatabase();
		
		$result = $db->query("select * from " . $db->escape ( $this->membersTable ) . " where  " . $db->escape ( $this->idField ) . " = '" . $db->escape ( $userId ) . "'");
		
		define('IN_PHPBB',1);
		
		$phpbb_root_path = realpath('../..')."/";
	
		$phpEx = substr(strrchr(__FILE__, '.'), 1);
	
		define('PHPBB_ROOT_PATH',$phpbb_root_path);
	
		include_once $phpbb_root_path."/common.php";
		
		$passwordIsValid = false;
		
		if( phpbb_check_hash ( $password , $result [ $this->passwordField ] ) )
		{
			return $row[$password_field];
		}
		
		return "";
	}
 }
 
 
 ?>