<?php
// -----------------------------------------------------------
// GChat Video Chat - http://www.gchat.com/video-chat.html
// Copyright (C) 2013 GChat Limited. All rights reserved.
// GChat Video Chat is not a free software, see LICENSE file
// -----------------------------------------------------------
 
defined('VISICHAT_START') or die("Access Denied");

require_once "IntegrationModule.class.php";

/*
 * Video Chat VBulletin integration class
 *
 */
 class VBulletin extends IntegrationModule
 {
	 
	 private $allowRegistration = false;	 

	 /**
	* VBulletin object constructor
	*
	* @access	public
	*/	
	function __construct()
	{
		parent::__construct(); 
	}
	
	/**
	* Indicates whether when this integration is used, can use register or not.
	*
	* @return boolean
	*/
	public function allowRegistration()
	{
		return $this->allowRegistration;
	}
	
	/**
	* Get the module name
	*
	* @return string
	*/
	public function getName()
	{
		return "VBulletin";
	}
	
	/**
	* Get the module label
	*
	* @return string
	*/
	public function getLabel()
	{
		return "VBulletin";
	}
	
	/**
	* Get user id of the user from session data
	*
	* @return integer
	*/
	public function getCurrentUserId()
	{
		
		require_once ( $_SERVER['DOCUMENT_ROOT'] . "/includes/config.php"); // Edit this if required
		
		$sessionId = $_COOKIE[$config['Misc']['cookieprefix']."sessionhash"];
		
		// Database instance
		$db = Factory::getDatabase();
		
		$result = $db->query("select * from " . $db->escape ( $this->integrationPrefix ) . "session where sessionhash = '" . $db->escape ( $sessionId ) . "'");
		
		if ( count ( $result ) > 0 )
		{
			return ( $result [0]["userid"] );
		}
		
		return "";
	}
	
	/**
	* Get picture of the user
	*
	* @return string
	*/
	public function getPicture( $userId )
	{
		return "";
	}
	
	/**
	* Get the user birthday
	*
	* @return timestamp
	*/
	public function getBirthday ( $userId )
	{
		if ( $userId == "" )
		{
			return "";
		}
		
		// Database instance
		$db = Factory::getDatabase();
		
		$result = $db->query("select birthday from " . $db->escape ( $this->membersTable ) . " where  " . $db->escape ( $this->idField ) . " = '" . $db->escape ( $userId ) . "'");

		// Check the password
		if ( count ( $result ) > 0 && $db->error == "" )
		{
			if ( $result[0]["birthday"] != "" )
			{
				return strtotime ( $result[0]["birthday"] );
			}
		}
		
		return "";
	}
	
	/**
	* Get the user gender
	*
	* @return string m (male), f (female), n (not specified), c (couple)
	*/
	public function getGender ( $userId )
	{
		return "";
	}
	
	/**
	* Encrypt the user password
	*
	* @return string	encrypted password
	*/
	public function encryptPassword ( $password , $userId = "" )
	{
		
		if ( $userId == "" )
		{
			throw new Exception ("User ID is required");
		}
		
		// Database instance
		$db = Factory::getDatabase();
		
		$result = $db->query("select * from " . $db->escape ( $this->membersTable ) . " where  " . $db->escape ( $this->idField ) . " = '" . $db->escape ( $userId ) . "'");

		// Check the password
		if ( count ( $result ) > 0 && $db->error == "" )
		{
			if( $result[0][$this->passwordField]  ==  md5 ( md5 ( $password ) . $result[0]["salt"] ) )
			{
				return md5 ( md5 ( $password ) . $result[0]["salt"] );
			}
		}
		
		return "";
	}
 }
 
 
 ?>