<?php
/*{@@COPYRIGHT@@}*/
 
defined('VISICHAT_START') or die("Access Denied");

/*
 * Video Chat AlloPass class
 *
 */
class AlloPass
{
	private $name 		= "AlloPass";
	private $options	= array();
	private $paymentMethod = NULL;
	private $transactionId = "";
	
	function __construct( $paymentMethod = NULL )
	{
		
		$this->paymentMethod = $paymentMethod;
		$this->options 	 = array();
		$this->options[] = array ("authCode" => "auth #  xxxxxx/xxxxxx/xxxxxx");
		$this->options[] = array ("countryCode" => "2 character country code");
		$this->transactionId = "";
	}

	//*********************
	// Setters and Getters
	//*********************
	
	/**
	 * Get name of the gateway
	 * 
	 * @return string
	 */ 
	public function getName()
	{
		return $this->name;
	}
	
	/**
	* Get associated payment method
	*
	* @return Payment Method
	*/
	public function getPaymentMethod()
	{
		return $this->paymentMethod;
	}
	
	/**
	* Get options of this gateway
	*
	* @return array
	*/
	public function getOptions()
	{
		return $this->options;
	}
	
	/**
	* Return the transaction id on successful order
	*
	* @return String
	*/
	public function getTransactionId()
	{
		return $this->transactionId;
	}
	
	/**
	* Generate payment form
	*
	* @return string
	*/
	public function getForm( $userId , $referralId )
	{
		$authCode = $this->getPaymentMethod()->getOption("authCode");
		$countryCode =$this->getPaymentMethod()->getOption("countryCode");
		
		$authParts = explode ("/" , $authCode );
		
		if ( count ( $authParts ) != 3 )
		{
			die ("Auth # is not valid");
		}
		
		$button = "";
		
		$button .= '<script type="text/javascript" src="https://payment.allopass.com/buy/checkout.apu?ids=' . $authParts[0] . '&idd=' . $authParts[1] . '&lang=en&country='.$countryCode.'"></script>';
		$button .= '<noscript><a href="https://payment.allopass.com/buy/buy.apu?ids=' . $authParts[0] . '&idd=' . $authParts[1] . '&country='.$countryCode.'" style="border:0">';
		$button .= '<img src="https://payment.allopass.com/static/buy/button/en/162x56.png" style="border:0" alt="Buy now!" /></a></noscript>';

		return $button;
	}
	
	/**
	* Verify if the payment has been sent
	*
	*/
	public function verify()
	{
		
		$this->transactionId = "";
		
		$ticket = urlencode ( get("RECALL") );
		
		$authCode = $this->getPaymentMethod()->getOption("authCode");
		
		$authParts = explode ("/" , $authCode );
		
		if ( count ( $authParts ) != 3 )
		{
			die ("Auth # is not valid");
		}
		
		@file("http://www.allopass.com/check/index.php4?CODE=" . $ticket . "&SITE_ID=" . $authParts[0] ."&DOC_ID=" . $authParts[1] );
		$r = @file("http://www.allopass.com/check/vf.php4?CODE=" . $ticket . "&AUTH=" . $authCode );
		
		if ( ereg ( "ERR" , $r[0] ) || ereg("NOK" , $r[0] ) )
		{
			return false;
		}
		
		$this->transactionId = $ticket;
		
		return true;
	}
}

?>